use optimle::Puzzle;
use serde::Serialize;
use wordlelike::guess::*;

#[derive(Serialize)]
struct ResultOutput {
    word: String,
    matches: Vec<u8>,
}

#[derive(Serialize)]
struct PuzzleOutput {
    history: Vec<ResultOutput>,
    seed: u64,
    solutions: usize,
}

impl PuzzleOutput {

}

fn main() {
    let common_words: Vec<Word<5>> = wordlelike::load::load_words(include_str!("../../wordlelike/src/words/common.txt"));
    for heres in 2..=4 {
        println!("heres: {}", heres);
        for seed in 16..=365 {
            let puzzle = Puzzle::generate(&common_words, seed, heres);
            println!("{}", serde_json::to_string(&PuzzleOutput {
                history: puzzle.history
                    .iter()
                    .map(|res| ResultOutput {
                        word: res.word.iter().collect(),
                        matches: res.matches
                            .iter()
                            .map(|m| match m {
                                LetterMatch::NOWHERE => 0,
                                LetterMatch::ELSEWHERE => 1,
                                LetterMatch::HERE => 2,
                            })
                            .collect(),
                    })
                    .collect(),
                seed: puzzle.seed,
                solutions: puzzle.solutions,
            }).unwrap());
        }
    }
}
